#!/usr/bin/python



import serial
import struct
import stat
import os
import time
import signal
import random
from optparse import OptionParser


count  = 0

global exit_loop
exit_loop = False



def handler(signum, frame):
    show_count()


def show_count():
    global count
    print "Writing Summary: count=%d\n" % ( count )

signal.signal(signal.SIGHUP, handler)


usage  = """usage: %prog -p PORT  [ options ]
     [-b | --baud ] BAUDRATE 
     [-m | --maxbytes] MAXBYTES
"""
parser = OptionParser(usage,add_help_option=True)
parser.add_option("-p","--serial", dest="port",help="Required port")
parser.add_option("-b","--baud", type="int",dest="baud" , default=9600)
parser.add_option("-m","--maxbytes",type="int",dest="maxbytes" )
parser.add_option("-t","--timeout",type="int",dest="timeout" , default=1)
exit_loop = False
(options,args) = parser.parse_args()

if options.port == None:
    parser.error( "Please serecify a port, -p PORT" )

if stat.S_ISFIFO(os.stat(options.port).st_mode):
    ser = file(options.port,"r")
else:
    ser = serial.Serial(port=options.port, timeout=options.timeout, baudrate=options.baud )
    ser.setDTR(1)
    time.sleep(0.5)



while not exit_loop:
    try:
        tmpdat = "".join([ "".join([struct.pack("B",i) for i in xrange(0,255)]) for x in range(1,random.randint(2,20)) ])
        count += ser.write(tmpdat)
        if options.maxbytes and count > options:
            exit_loop = True
            break
    except KeyboardInterrupt:
        print "Ending"
        exit_loop = True
    except serial.serialutil.SerialException:
        print "Ignoring Serial Exception"
    finally:
        next

print "Writing Summary: count=%d" % ( count )


